unit MLfinty; {zalozene 22. augusta 1996 - Marek Laco}
              {kniznica rouznych fiint}

interface
  procedure Jas(n: integer);
  {obrazovka vo vs. gr. rezimoch bude svietit zadanym jasom}
  {63 - default, 20 - priitmie, 0 - tma,   >63 - cudne farby}
  procedure Zasviet(_delay: byte);
  {zadanou rychlostou zasvieti zhasnutu obrazovku vo vsetkych gr. modoch}
  procedure Zhasni(_delay: byte);
  {zadanou rychlostou zhasne obrazovku vo vsetkych gr. modoch}
  procedure ScrOn;
  {zapne obrazovku}
  procedure ScrOff;
  {vypne obrazovku, bude zatial cierna}
  {zhasne a zapne obrazovku, ak sa ma nieco pomale nan vykreslovat}
  {zhasnut, nakreslit, zasvietit}
  procedure VRamOn;
  {odblokuje Vram}
  procedure VRamOff;
  {zablokuje Vram, napr aby ina aplikacia nepisala blbosti...}
  procedure SaveSCR1; {ulozi textovu obrazovku na stranku c 1}
  procedure LoadSCR1; {natiahne textovu obrazovku zo stranky c 1}
  procedure SaveSCR2; {ulozi textovu obrazovku na stranku c 2}
  procedure LoadSCR2; {natiahne textovu obrazovku zo stranky c 2}
  procedure SaveSCR3; {ulozi textovu obrazovku na stranku c 3}
  procedure LoadSCR3; {natiahne textovu obrazovku zo stranky c 3}
  procedure HydeCursor; {v textovej obrazovke nebude blikajuci kurzor}
  procedure ShowCursor; {obnovy kurzor}
  procedure Led(B: byte); {obsluha LED diod klavesnice b = 0..7}


implementation

uses crt, dos;

type paleta = array[1..768] of byte;

var      p: paleta;
         i: integer;
    Hl_str: byte absolute $B800:$0000;
      Str1: byte absolute $B800:$0FA0;
      Str2: byte absolute $B800:$1F40;
      Str3: byte absolute $B800:$2EE0;


{---------------------------------------------------------}

procedure Jas(n: integer);
var I: integer;
begin
  port[$3c8] := 0;
  for i := 1 to 768 do port[$3c9] := p[I]*n div 63;
end;

procedure ZP;
var I: integer;
begin
  port[$3c7] := 0;
  for i := 1 to 768 do p[i] := port[$3c9];
end;

procedure Zasviet(_delay: byte);
var n: integer;
begin
  for n := 0 to 63 do
    begin
      Jas(n);
      Delay(_delay);
    end;
end;

procedure Zhasni(_delay: byte);
var n: integer;
begin
  ZP;
  for n := 63 downto 0 do
    begin
      Jas(n);
      Delay(_delay);
    end;
end;

{--------------------------------------------------------}

procedure ScrOn;
begin
  Port[$3c4] := 1;
  Port[$3c5] := Port[$3c5] and $df;
end;

procedure ScrOff;
begin
  Port[$3c4] := 1;
  Port[$3c5] := Port[$3c5] or $20
end;

{--------------------------------------------------------}

procedure VRamOn;
begin
  Port[$3c2] := Port[$3cc] or 2;
end;

procedure  VRamOff;
begin
  Port[$3c2] := Port[$3cc] and $fd;
end;

{--------------------------------------------------------}

procedure SaveSCR1;
begin
  Move(Hl_str, str1, 4000);
end;

procedure LoadSCR1;
begin
  Move(str1, Hl_str, 4000);
end;

procedure SaveSCR2;
begin
  Move(Hl_str, str2, 4000);
end;

procedure LoadSCR2;
begin
  Move(str2, Hl_str, 4000);
end;

procedure SaveSCR3;
begin
  Move(Hl_str, str3, 4000);
end;

procedure LoadSCR3;
begin
  Move(str3, Hl_str, 4000);
end;

{------------------------------------------------------------------}

procedure HydeCursor;
var r: registers;
begin
  with r do
    begin
      ah := 1;
      bh := 0;
      cx := $2000;
      intr($10, r);
   end;
end;

procedure ShowCursor;
var r: registers;
begin
  with r do
    begin
      ah := 1;
      bh := 0;
      cx := $0607;
      intr($10, r);
   end;
end;

{-------------------------------------------------------------------}

{bit 7654321                                  }
{    ....CNS     C-caps, N-mum, S-scroll lock }
{                                             }
{   00000111 hex = 7 = vsetky lock-y          }
{   _______ }
{   000 = 0 }
{   010 = 2 }
{   011 = 3 }
{   100 = 4 }
{   101 = 5 }
{   110 = 6 }
{   111 = 7 }

procedure Led(B: byte);
begin
  asm
    mov al,0edh
    out 60h,al
    mov al,B
    out 60h,al
  end;
end;



end.




